diff --git a/compiler/iface/IfaceSyn.lhs b/compiler/iface/IfaceSyn.lhs
index 28098ae..174b37b 100644
--- a/compiler/iface/IfaceSyn.lhs
+++ b/compiler/iface/IfaceSyn.lhs
@@ -4,12 +4,6 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module IfaceSyn (
         module IfaceType,
@@ -632,12 +626,12 @@ data IfaceExpr
   | IfaceExt    IfExtName
   | IfaceType   IfaceType
   | IfaceCo     IfaceCoercion
-  | IfaceTuple 	TupleSort [IfaceExpr]	-- Saturated; type arguments omitted
-  | IfaceLam 	IfaceBndr IfaceExpr
-  | IfaceApp 	IfaceExpr IfaceExpr
-  | IfaceCase	IfaceExpr IfLclName [IfaceAlt]
+  | IfaceTuple  TupleSort [IfaceExpr]   -- Saturated; type arguments omitted
+  | IfaceLam    IfaceBndr IfaceExpr
+  | IfaceApp    IfaceExpr IfaceExpr
+  | IfaceCase   IfaceExpr IfLclName [IfaceAlt]
   | IfaceECase  IfaceExpr IfaceType     -- See Note [Empty case alternatives]
-  | IfaceLet	IfaceBinding  IfaceExpr
+  | IfaceLet    IfaceBinding  IfaceExpr
   | IfaceCast   IfaceExpr IfaceCoercion
   | IfaceLit    Literal
   | IfaceFCall  ForeignCall IfaceType
@@ -1203,15 +1197,15 @@ pprIfaceExpr add_par (IfaceECase scrut ty)
 
 pprIfaceExpr add_par (IfaceCase scrut bndr [(con, bs, rhs)])
   = add_par (sep [ptext (sLit "case") 
-			<+> pprIfaceExpr noParens scrut <+> ptext (sLit "of") 
-			<+> ppr bndr <+> char '{' <+> ppr_con_bs con bs <+> arrow,
-  		  pprIfaceExpr noParens rhs <+> char '}'])
+                        <+> pprIfaceExpr noParens scrut <+> ptext (sLit "of") 
+                        <+> ppr bndr <+> char '{' <+> ppr_con_bs con bs <+> arrow,
+                  pprIfaceExpr noParens rhs <+> char '}'])
 
 pprIfaceExpr add_par (IfaceCase scrut bndr alts)
   = add_par (sep [ptext (sLit "case") 
-		 	<+> pprIfaceExpr noParens scrut <+> ptext (sLit "of") 
-			<+> ppr bndr <+> char '{',
-  		  nest 2 (sep (map ppr_alt alts)) <+> char '}'])
+                        <+> pprIfaceExpr noParens scrut <+> ptext (sLit "of") 
+                        <+> ppr bndr <+> char '{',
+                  nest 2 (sep (map ppr_alt alts)) <+> char '}'])
 
 pprIfaceExpr _       (IfaceCast expr co)
   = sep [pprParendIfaceExpr expr,
diff --git a/compiler/main/PprTyThing.hs b/compiler/main/PprTyThing.hs
index 947d8b2..cba8ea0 100644
--- a/compiler/main/PprTyThing.hs
+++ b/compiler/main/PprTyThing.hs
@@ -6,20 +6,14 @@
 --
 -----------------------------------------------------------------------------
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module PprTyThing (
-	pprTyThing,
-	pprTyThingInContext, 
-	pprTyThingLoc,
-	pprTyThingInContextLoc,
-	pprTyThingHdr,
-  	pprTypeForUser
+        pprTyThing,
+        pprTyThingInContext, 
+        pprTyThingLoc,
+        pprTyThingInContextLoc,
+        pprTyThingHdr,
+        pprTypeForUser
   ) where
 
 import qualified GHC
@@ -120,8 +114,8 @@ pprTyConHdr tyCon
     <+> pprTvBndrs (suppressKinds dflags (tyConKind tyCon) vars)
   where
     vars | GHC.isPrimTyCon tyCon ||
-	   GHC.isFunTyCon tyCon = take (GHC.tyConArity tyCon) GHC.alphaTyVars
-	 | otherwise = GHC.tyConTyVars tyCon
+           GHC.isFunTyCon tyCon = take (GHC.tyConArity tyCon) GHC.alphaTyVars
+         | otherwise = GHC.tyConTyVars tyCon
 
     keyword | GHC.isSynTyCon tyCon = sLit "type"
             | GHC.isNewTyCon tyCon = sLit "newtype"
@@ -131,9 +125,9 @@ pprTyConHdr tyCon
       | GHC.isFamilyTyCon tyCon = ptext (sLit "family")
       | otherwise             = empty
 
-    opt_stupid 	-- The "stupid theta" part of the declaration
-	| isAlgTyCon tyCon = GHC.pprThetaArrowTy (tyConStupidTheta tyCon)
-	| otherwise	   = empty	-- Returns 'empty' if null theta
+    opt_stupid  -- The "stupid theta" part of the declaration
+        | isAlgTyCon tyCon = GHC.pprThetaArrowTy (tyConStupidTheta tyCon)
+        | otherwise        = empty      -- Returns 'empty' if null theta
 
 pprDataConSig :: GHC.DataCon -> SDoc
 pprDataConSig dataCon
@@ -153,17 +147,17 @@ pprClassHdr cls
 pprId :: Var -> SDoc
 pprId ident
   = hang (ppr_bndr ident <+> dcolon)
-	 2 (pprTypeForUser (GHC.idType ident))
+         2 (pprTypeForUser (GHC.idType ident))
 
 pprTypeForUser :: GHC.Type -> SDoc
 -- We do two things here.
 -- a) We tidy the type, regardless
 -- b) If Opt_PrintExplicitForAlls is True, we discard the foralls
--- 	but we do so `deeply'
+--      but we do so `deeply'
 -- Prime example: a class op might have type
---	forall a. C a => forall b. Ord b => stuff
+--      forall a. C a => forall b. Ord b => stuff
 -- Then we want to display
---	(C a, Ord b) => stuff
+--      (C a, Ord b) => stuff
 pprTypeForUser ty
   = sdocWithDynFlags $ \ dflags ->
     if gopt Opt_PrintExplicitForalls dflags
@@ -206,9 +200,9 @@ pprTyCon ss tyCon
 pprAlgTyCon :: ShowSub -> TyCon -> SDoc
 pprAlgTyCon ss tyCon
   | gadt      = pprTyConHdr tyCon <+> ptext (sLit "where") $$
-		   nest 2 (vcat (ppr_trim (map show_con datacons)))
+                   nest 2 (vcat (ppr_trim (map show_con datacons)))
   | otherwise = hang (pprTyConHdr tyCon)
-    		   2 (add_bars (ppr_trim (map show_con datacons)))
+                   2 (add_bars (ppr_trim (map show_con datacons)))
   where
     datacons = GHC.tyConDataCons tyCon
     gadt = any (not . GHC.isVanillaDataCon) datacons
@@ -222,8 +216,8 @@ pprDataConDecl :: ShowSub -> Bool -> GHC.DataCon -> SDoc
 pprDataConDecl ss gadt_style dataCon
   | not gadt_style = ppr_fields tys_w_strs
   | otherwise      = ppr_bndr dataCon <+> dcolon <+>
-			sep [ pp_foralls, GHC.pprThetaArrowTy theta, pp_tau ]
-	-- Printing out the dataCon as a type signature, in GADT style
+                        sep [ pp_foralls, GHC.pprThetaArrowTy theta, pp_tau ]
+        -- Printing out the dataCon as a type signature, in GADT style
   where
     (forall_tvs, theta, tau) = tcSplitSigmaTy (GHC.dataConUserType dataCon)
     (arg_tys, res_ty)        = tcSplitFunTys tau
@@ -248,18 +242,18 @@ pprDataConDecl ss gadt_style dataCon
     user_ify bang                      = bang
 
     maybe_show_label (lbl,bty)
-	| showSub ss lbl = Just (ppr_bndr lbl <+> dcolon <+> pprBangTy bty)
-	| otherwise      = Nothing
+        | showSub ss lbl = Just (ppr_bndr lbl <+> dcolon <+> pprBangTy bty)
+        | otherwise      = Nothing
 
     ppr_fields [ty1, ty2]
-	| GHC.dataConIsInfix dataCon && null labels
-	= sep [pprParendBangTy ty1, pprInfixName dataCon, pprParendBangTy ty2]
+        | GHC.dataConIsInfix dataCon && null labels
+        = sep [pprParendBangTy ty1, pprInfixName dataCon, pprParendBangTy ty2]
     ppr_fields fields
-	| null labels
-	= ppr_bndr dataCon <+> sep (map pprParendBangTy fields)
-	| otherwise
-	= ppr_bndr dataCon
-	  <+> (braces $ sep $ punctuate comma $ ppr_trim $
+        | null labels
+        = ppr_bndr dataCon <+> sep (map pprParendBangTy fields)
+        | otherwise
+        = ppr_bndr dataCon
+          <+> (braces $ sep $ punctuate comma $ ppr_trim $
                map maybe_show_label (zip labels fields))
 
 pprClass :: ShowSub -> GHC.Class -> SDoc
@@ -274,7 +268,7 @@ pprClass ss cls
     methods  = GHC.classMethods cls
     assoc_ts = GHC.classATs cls
     show_meth id | showSub ss id  = Just (pprClassMethod id)
-	         | otherwise      = Nothing
+                 | otherwise      = Nothing
     show_at tc = case showSub_maybe ss tc of
                       Just ss' -> Just (pprTyCon ss' tc)
                       Nothing  -> Nothing
@@ -287,12 +281,12 @@ pprClassMethod id
   -- from the class op type.  Stolen from IfaceSyn.tyThingToIfaceDecl.
   --
   -- It's important to tidy it *before* splitting it up, so that if
-  -- we have	class C a b where
-  --	          op :: forall a. a -> b
+  -- we have    class C a b where
+  --              op :: forall a. a -> b
   -- then the inner forall on op gets renamed to a1, and we print
   -- (when dropping foralls)
-  --		class C a b where
-  --		  op :: a1 -> b
+  --            class C a b where
+  --              op :: a1 -> b
 
   tidy_sel_ty = tidyTopType (GHC.idType id)
   (_sel_tyvars, rho_ty) = GHC.splitForAllTys tidy_sel_ty
@@ -319,7 +313,7 @@ ppr_bndr a = GHC.pprParenSymName a
 showWithLoc :: SDoc -> SDoc -> SDoc
 showWithLoc loc doc
     = hang doc 2 (char '\t' <> comment <+> loc)
-		-- The tab tries to make them line up a bit
+                -- The tab tries to make them line up a bit
   where
     comment = ptext (sLit "--")
 
diff --git a/compiler/nativeGen/PPC/Cond.hs b/compiler/nativeGen/PPC/Cond.hs
index b8c5208..0c525f8 100644
--- a/compiler/nativeGen/PPC/Cond.hs
+++ b/compiler/nativeGen/PPC/Cond.hs
@@ -1,17 +1,11 @@
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module PPC.Cond (
-	Cond(..),
-	condNegate,
-	condUnsigned,
-	condToSigned,
-	condToUnsigned,
+        Cond(..),
+        condNegate,
+        condUnsigned,
+        condToSigned,
+        condToUnsigned,
 )
 
 where
@@ -19,18 +13,18 @@ where
 import Panic
 
 data Cond
-	= ALWAYS
-	| EQQ
-	| GE
-	| GEU
-	| GTT
-	| GU
-	| LE
-	| LEU
-	| LTT
-	| LU
-	| NE
-	deriving Eq
+        = ALWAYS
+        | EQQ
+        | GE
+        | GEU
+        | GTT
+        | GU
+        | LE
+        | LEU
+        | LTT
+        | LU
+        | NE
+        deriving Eq
 
 
 condNegate :: Cond -> Cond
diff --git a/compiler/nativeGen/PPC/RegInfo.hs b/compiler/nativeGen/PPC/RegInfo.hs
index 8b35d87..2bf4091 100644
--- a/compiler/nativeGen/PPC/RegInfo.hs
+++ b/compiler/nativeGen/PPC/RegInfo.hs
@@ -6,19 +6,13 @@
 --
 -----------------------------------------------------------------------------
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module PPC.RegInfo (
         JumpDest( DestBlockId ), getJumpDestBlockId,
-	canShortcut, 
-	shortcutJump, 
+        canShortcut, 
+        shortcutJump, 
 
-	shortcutStatics
+        shortcutStatics
 )
 
 where
@@ -69,9 +63,9 @@ shortcutStatic _ other_static
         = other_static
 
 shortBlockId 
-	:: (BlockId -> Maybe JumpDest)
-	-> BlockId
-	-> CLabel
+        :: (BlockId -> Maybe JumpDest)
+        -> BlockId
+        -> CLabel
 
 shortBlockId fn blockid =
    case fn blockid of
diff --git a/compiler/nativeGen/Reg.hs b/compiler/nativeGen/Reg.hs
index fee74be..0633e59 100644
--- a/compiler/nativeGen/Reg.hs
+++ b/compiler/nativeGen/Reg.hs
@@ -1,36 +1,30 @@
 
 -- | An architecture independent description of a register.
---	This needs to stay architecture independent because it is used
---	by NCGMonad and the register allocators, which are shared
---	by all architectures.
+--      This needs to stay architecture independent because it is used
+--      by NCGMonad and the register allocators, which are shared
+--      by all architectures.
 --
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module Reg (
-	RegNo,
-	Reg(..),
-	regPair,
-	regSingle,
-	isRealReg,	takeRealReg,
-	isVirtualReg,	takeVirtualReg,
-	
-	VirtualReg(..),
-	renameVirtualReg,
-	classOfVirtualReg,
-	getHiVirtualRegFromLo,
-	getHiVRegFromLo,
-
-	RealReg(..),
-	regNosOfRealReg,
-	realRegsAlias,
-	
-	liftPatchFnToRegReg
+        RegNo,
+        Reg(..),
+        regPair,
+        regSingle,
+        isRealReg,      takeRealReg,
+        isVirtualReg,   takeVirtualReg,
+        
+        VirtualReg(..),
+        renameVirtualReg,
+        classOfVirtualReg,
+        getHiVirtualRegFromLo,
+        getHiVRegFromLo,
+
+        RealReg(..),
+        regNosOfRealReg,
+        realRegsAlias,
+        
+        liftPatchFnToRegReg
 )
 
 where
@@ -42,67 +36,67 @@ import Data.List
 
 -- | An identifier for a primitive real machine register.
 type RegNo 
-	= Int
+        = Int
 
 -- VirtualRegs are virtual registers.  The register allocator will
--- 	eventually have to map them into RealRegs, or into spill slots.
+--      eventually have to map them into RealRegs, or into spill slots.
 --
--- 	VirtualRegs are allocated on the fly, usually to represent a single
--- 	value in the abstract assembly code (i.e. dynamic registers are
--- 	usually single assignment).  
+--      VirtualRegs are allocated on the fly, usually to represent a single
+--      value in the abstract assembly code (i.e. dynamic registers are
+--      usually single assignment).  
 --
---	The  single assignment restriction isn't necessary to get correct code,
--- 	although a better register allocation will result if single
--- 	assignment is used -- because the allocator maps a VirtualReg into
--- 	a single RealReg, even if the VirtualReg has multiple live ranges.
+--      The  single assignment restriction isn't necessary to get correct code,
+--      although a better register allocation will result if single
+--      assignment is used -- because the allocator maps a VirtualReg into
+--      a single RealReg, even if the VirtualReg has multiple live ranges.
 --
--- 	Virtual regs can be of either class, so that info is attached.
+--      Virtual regs can be of either class, so that info is attached.
 --
 data VirtualReg
-	= VirtualRegI  {-# UNPACK #-} !Unique
-	| VirtualRegHi {-# UNPACK #-} !Unique  -- High part of 2-word register
-	| VirtualRegF  {-# UNPACK #-} !Unique
-	| VirtualRegD  {-# UNPACK #-} !Unique
-	| VirtualRegSSE {-# UNPACK #-} !Unique
-	deriving (Eq, Show, Ord)
+        = VirtualRegI  {-# UNPACK #-} !Unique
+        | VirtualRegHi {-# UNPACK #-} !Unique  -- High part of 2-word register
+        | VirtualRegF  {-# UNPACK #-} !Unique
+        | VirtualRegD  {-# UNPACK #-} !Unique
+        | VirtualRegSSE {-# UNPACK #-} !Unique
+        deriving (Eq, Show, Ord)
 
 instance Uniquable VirtualReg where
-	getUnique reg
-	 = case reg of
-	 	VirtualRegI u	-> u
-		VirtualRegHi u	-> u
-		VirtualRegF u	-> u
-		VirtualRegD u	-> u
-		VirtualRegSSE u	-> u
+        getUnique reg
+         = case reg of
+                VirtualRegI u   -> u
+                VirtualRegHi u  -> u
+                VirtualRegF u   -> u
+                VirtualRegD u   -> u
+                VirtualRegSSE u -> u
 
 instance Outputable VirtualReg where
-	ppr reg
-	 = case reg of
-		VirtualRegI  u  -> text "%vI_" 	<> pprUnique u
-		VirtualRegHi u  -> text "%vHi_" <> pprUnique u
-		VirtualRegF  u  -> text "%vF_" 	<> pprUnique u
-		VirtualRegD  u  -> text "%vD_" 	<> pprUnique u
-		VirtualRegSSE u -> text "%vSSE_" <> pprUnique u
+        ppr reg
+         = case reg of
+                VirtualRegI  u  -> text "%vI_"  <> pprUnique u
+                VirtualRegHi u  -> text "%vHi_" <> pprUnique u
+                VirtualRegF  u  -> text "%vF_"  <> pprUnique u
+                VirtualRegD  u  -> text "%vD_"  <> pprUnique u
+                VirtualRegSSE u -> text "%vSSE_" <> pprUnique u
 
 
 renameVirtualReg :: Unique -> VirtualReg -> VirtualReg
 renameVirtualReg u r
  = case r of
-	VirtualRegI _	-> VirtualRegI  u
-	VirtualRegHi _	-> VirtualRegHi u
-	VirtualRegF _	-> VirtualRegF  u
-	VirtualRegD _	-> VirtualRegD  u
-	VirtualRegSSE _	-> VirtualRegSSE u
+        VirtualRegI _   -> VirtualRegI  u
+        VirtualRegHi _  -> VirtualRegHi u
+        VirtualRegF _   -> VirtualRegF  u
+        VirtualRegD _   -> VirtualRegD  u
+        VirtualRegSSE _ -> VirtualRegSSE u
 
 
 classOfVirtualReg :: VirtualReg -> RegClass
 classOfVirtualReg vr
  = case vr of
- 	VirtualRegI{}	-> RcInteger
-	VirtualRegHi{}	-> RcInteger
-	VirtualRegF{}	-> RcFloat
-	VirtualRegD{}	-> RcDouble
-	VirtualRegSSE{}	-> RcDoubleSSE
+        VirtualRegI{}   -> RcInteger
+        VirtualRegHi{}  -> RcInteger
+        VirtualRegF{}   -> RcFloat
+        VirtualRegD{}   -> RcDouble
+        VirtualRegSSE{} -> RcDoubleSSE
 
 
 -- Determine the upper-half vreg for a 64-bit quantity on a 32-bit platform
@@ -111,118 +105,118 @@ classOfVirtualReg vr
 getHiVirtualRegFromLo :: VirtualReg -> VirtualReg
 getHiVirtualRegFromLo reg
  = case reg of
-	-- makes a pseudo-unique with tag 'H'
- 	VirtualRegI u	-> VirtualRegHi (newTagUnique u 'H') 
-	_		-> panic "Reg.getHiVirtualRegFromLo"
+        -- makes a pseudo-unique with tag 'H'
+        VirtualRegI u   -> VirtualRegHi (newTagUnique u 'H') 
+        _               -> panic "Reg.getHiVirtualRegFromLo"
 
 getHiVRegFromLo :: Reg -> Reg
 getHiVRegFromLo reg
  = case reg of
- 	RegVirtual  vr	-> RegVirtual (getHiVirtualRegFromLo vr)
-	RegReal _	-> panic "Reg.getHiVRegFromLo"
- 	
+        RegVirtual  vr  -> RegVirtual (getHiVirtualRegFromLo vr)
+        RegReal _       -> panic "Reg.getHiVRegFromLo"
+        
 
 ------------------------------------------------------------------------------------
 -- | RealRegs are machine regs which are available for allocation, in
--- 	the usual way.  We know what class they are, because that's part of
--- 	the processor's architecture.
+--      the usual way.  We know what class they are, because that's part of
+--      the processor's architecture.
 --
--- 	RealRegPairs are pairs of real registers that are allocated together
---	to hold a larger value, such as with Double regs on SPARC.
+--      RealRegPairs are pairs of real registers that are allocated together
+--      to hold a larger value, such as with Double regs on SPARC.
 --
 data RealReg
-	= RealRegSingle	{-# UNPACK #-} !RegNo
-	| RealRegPair	{-# UNPACK #-} !RegNo {-# UNPACK #-} !RegNo
-	deriving (Eq, Show, Ord)
+        = RealRegSingle {-# UNPACK #-} !RegNo
+        | RealRegPair   {-# UNPACK #-} !RegNo {-# UNPACK #-} !RegNo
+        deriving (Eq, Show, Ord)
 
 instance Uniquable RealReg where
-	getUnique reg
-	 = case reg of
-	 	RealRegSingle i		-> mkRegSingleUnique i
-		RealRegPair r1 r2	-> mkRegPairUnique (r1 * 65536 + r2)
+        getUnique reg
+         = case reg of
+                RealRegSingle i         -> mkRegSingleUnique i
+                RealRegPair r1 r2       -> mkRegPairUnique (r1 * 65536 + r2)
 
 instance Outputable RealReg where
-	ppr reg
-	 = case reg of
-	 	RealRegSingle i		-> text "%r" 	<> int i
-		RealRegPair r1 r2	-> text "%r(" <> int r1 <> text "|" <> int r2 <> text ")"
+        ppr reg
+         = case reg of
+                RealRegSingle i         -> text "%r"    <> int i
+                RealRegPair r1 r2       -> text "%r(" <> int r1 <> text "|" <> int r2 <> text ")"
 
 regNosOfRealReg :: RealReg -> [RegNo]
 regNosOfRealReg rr
  = case rr of
- 	RealRegSingle r1	-> [r1]
-	RealRegPair   r1 r2	-> [r1, r2]
-	
+        RealRegSingle r1        -> [r1]
+        RealRegPair   r1 r2     -> [r1, r2]
+        
 
 realRegsAlias :: RealReg -> RealReg -> Bool
 realRegsAlias rr1 rr2
-	= not $ null $ intersect (regNosOfRealReg rr1) (regNosOfRealReg rr2)
+        = not $ null $ intersect (regNosOfRealReg rr1) (regNosOfRealReg rr2)
 
 --------------------------------------------------------------------------------
 -- | A register, either virtual or real
 data Reg
-	= RegVirtual !VirtualReg
-	| RegReal    !RealReg
-	deriving (Eq, Ord)
+        = RegVirtual !VirtualReg
+        | RegReal    !RealReg
+        deriving (Eq, Ord)
 
 regSingle :: RegNo -> Reg
-regSingle regNo		= RegReal $ RealRegSingle regNo
+regSingle regNo         = RegReal $ RealRegSingle regNo
 
 regPair :: RegNo -> RegNo -> Reg
-regPair regNo1 regNo2	= RegReal $ RealRegPair regNo1 regNo2
+regPair regNo1 regNo2   = RegReal $ RealRegPair regNo1 regNo2
 
 
 -- We like to have Uniques for Reg so that we can make UniqFM and UniqSets 
 -- in the register allocator.
 instance Uniquable Reg where
-	getUnique reg
-	 = case reg of
-	 	RegVirtual vr	-> getUnique vr
-		RegReal    rr	-> getUnique rr
-	
+        getUnique reg
+         = case reg of
+                RegVirtual vr   -> getUnique vr
+                RegReal    rr   -> getUnique rr
+        
 -- | Print a reg in a generic manner
---	If you want the architecture specific names, then use the pprReg 
---	function from the appropriate Ppr module.
+--      If you want the architecture specific names, then use the pprReg 
+--      function from the appropriate Ppr module.
 instance Outputable Reg where
-	ppr reg
-	 = case reg of
-	 	RegVirtual vr	-> ppr vr
-		RegReal    rr	-> ppr rr
+        ppr reg
+         = case reg of
+                RegVirtual vr   -> ppr vr
+                RegReal    rr   -> ppr rr
 
 
 isRealReg :: Reg -> Bool
 isRealReg reg 
  = case reg of
- 	RegReal _	-> True
-	RegVirtual _	-> False
+        RegReal _       -> True
+        RegVirtual _    -> False
 
 takeRealReg :: Reg -> Maybe RealReg
 takeRealReg reg
  = case reg of
- 	RegReal rr	-> Just rr
-	_		-> Nothing
+        RegReal rr      -> Just rr
+        _               -> Nothing
 
 
 isVirtualReg :: Reg -> Bool
 isVirtualReg reg
  = case reg of
- 	RegReal _	-> False
-	RegVirtual _	-> True
+        RegReal _       -> False
+        RegVirtual _    -> True
 
 takeVirtualReg :: Reg -> Maybe VirtualReg
 takeVirtualReg reg
  = case reg of
- 	RegReal _	-> Nothing
-	RegVirtual vr	-> Just vr
+        RegReal _       -> Nothing
+        RegVirtual vr   -> Just vr
 
 
 -- | The patch function supplied by the allocator maps VirtualReg to RealReg
---	regs, but sometimes we want to apply it to plain old Reg.
+--      regs, but sometimes we want to apply it to plain old Reg.
 --
 liftPatchFnToRegReg  :: (VirtualReg -> RealReg) -> (Reg -> Reg)
 liftPatchFnToRegReg patchF reg
  = case reg of
- 	RegVirtual vr	-> RegReal (patchF vr)
-	RegReal _	-> reg
-	
+        RegVirtual vr   -> RegReal (patchF vr)
+        RegReal _       -> reg
+        
 
diff --git a/compiler/nativeGen/RegClass.hs b/compiler/nativeGen/RegClass.hs
index 7ccc0c1..1494376 100644
--- a/compiler/nativeGen/RegClass.hs
+++ b/compiler/nativeGen/RegClass.hs
@@ -1,41 +1,35 @@
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 
 -- | An architecture independent description of a register's class.
 module RegClass 
-	( RegClass (..) )
+        ( RegClass (..) )
 
 where
 
-import	Outputable
-import	Unique
+import  Outputable
+import  Unique
 
 
 -- | The class of a register. 
---	Used in the register allocator.
---	We treat all registers in a class as being interchangable.
+--      Used in the register allocator.
+--      We treat all registers in a class as being interchangable.
 --
 data RegClass 
-	= RcInteger 
-	| RcFloat
-	| RcDouble
-	| RcDoubleSSE -- x86 only: the SSE regs are a separate class
-	deriving Eq
+        = RcInteger 
+        | RcFloat
+        | RcDouble
+        | RcDoubleSSE -- x86 only: the SSE regs are a separate class
+        deriving Eq
 
 
 instance Uniquable RegClass where
-    getUnique RcInteger	= mkRegClassUnique 0
-    getUnique RcFloat	= mkRegClassUnique 1
-    getUnique RcDouble	= mkRegClassUnique 2
+    getUnique RcInteger = mkRegClassUnique 0
+    getUnique RcFloat   = mkRegClassUnique 1
+    getUnique RcDouble  = mkRegClassUnique 2
     getUnique RcDoubleSSE = mkRegClassUnique 3
 
 instance Outputable RegClass where
-    ppr RcInteger	= Outputable.text "I"
-    ppr RcFloat		= Outputable.text "F"
-    ppr RcDouble	= Outputable.text "D"
-    ppr RcDoubleSSE	= Outputable.text "S"
+    ppr RcInteger       = Outputable.text "I"
+    ppr RcFloat         = Outputable.text "F"
+    ppr RcDouble        = Outputable.text "D"
+    ppr RcDoubleSSE     = Outputable.text "S"
diff --git a/compiler/nativeGen/SPARC/CodeGen/Amode.hs b/compiler/nativeGen/SPARC/CodeGen/Amode.hs
index 324eda9..927ed7b 100644
--- a/compiler/nativeGen/SPARC/CodeGen/Amode.hs
+++ b/compiler/nativeGen/SPARC/CodeGen/Amode.hs
@@ -1,13 +1,7 @@
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module SPARC.CodeGen.Amode (
-	getAmode
+        getAmode
 )
 
 where
@@ -29,8 +23,8 @@ import OrdList
 
 -- | Generate code to reference a memory address.
 getAmode 
-	:: CmmExpr 	-- ^ expr producing an address
-	-> NatM Amode
+        :: CmmExpr      -- ^ expr producing an address
+        -> NatM Amode
 
 getAmode tree@(CmmRegOff _ _) 
     = do dflags <- getDynFlags
@@ -50,7 +44,7 @@ getAmode (CmmMachOp (MO_Add _) [x, CmmLit (CmmInt i _)])
   = do
        (reg, code) <- getSomeReg x
        let
-     	 off  = ImmInt (fromInteger i)
+         off  = ImmInt (fromInteger i)
        return (Amode (AddrRegImm reg off) code)
 
 getAmode (CmmMachOp (MO_Add _) [x, y])
@@ -58,23 +52,23 @@ getAmode (CmmMachOp (MO_Add _) [x, y])
     (regX, codeX) <- getSomeReg x
     (regY, codeY) <- getSomeReg y
     let
-    	code = codeX `appOL` codeY
+        code = codeX `appOL` codeY
     return (Amode (AddrRegReg regX regY) code)
 
 getAmode (CmmLit lit)
   = do
-	let imm__2	= litToImm lit
-	tmp1 	<- getNewRegNat II32
-	tmp2	<- getNewRegNat II32
+        let imm__2      = litToImm lit
+        tmp1    <- getNewRegNat II32
+        tmp2    <- getNewRegNat II32
 
-	let code = toOL	[ SETHI (HI imm__2) tmp1
-			, OR    False tmp1 (RIImm (LO imm__2)) tmp2]
-		
-	return (Amode (AddrRegReg tmp2 g0) code)
+        let code = toOL [ SETHI (HI imm__2) tmp1
+                        , OR    False tmp1 (RIImm (LO imm__2)) tmp2]
+                
+        return (Amode (AddrRegReg tmp2 g0) code)
 
 getAmode other
   = do
        (reg, code) <- getSomeReg other
        let
-    	    off  = ImmInt 0
+            off  = ImmInt 0
        return (Amode (AddrRegImm reg off) code)
diff --git a/compiler/nativeGen/SPARC/CodeGen/CondCode.hs b/compiler/nativeGen/SPARC/CodeGen/CondCode.hs
index 375a9e1..4f23c55 100644
--- a/compiler/nativeGen/SPARC/CodeGen/CondCode.hs
+++ b/compiler/nativeGen/SPARC/CodeGen/CondCode.hs
@@ -1,15 +1,9 @@
 
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module SPARC.CodeGen.CondCode (
-	getCondCode,
-	condIntCode,
-	condFltCode
+        getCondCode,
+        condIntCode,
+        condFltCode
 )
 
 where
@@ -86,8 +80,8 @@ condIntCode cond x y = do
     (src1, code1) <- getSomeReg x
     (src2, code2) <- getSomeReg y
     let
-	code__2 = code1 `appOL` code2 `snocOL`
-    	    	  SUB False True src1 (RIReg src2) g0
+        code__2 = code1 `appOL` code2 `snocOL`
+                  SUB False True src1 (RIReg src2) g0
     return (CondCode False cond code__2)
 
 
@@ -98,19 +92,19 @@ condFltCode cond x y = do
     (src2, code2) <- getSomeReg y
     tmp <- getNewRegNat FF64
     let
-   	promote x = FxTOy FF32 FF64 x tmp
-
-    	pk1   = cmmExprType dflags x
-    	pk2   = cmmExprType dflags y
-
-    	code__2 =
-		if pk1 `cmmEqType` pk2 then
-    	            code1 `appOL` code2 `snocOL`
-    	    	    FCMP True (cmmTypeSize pk1) src1 src2
-    	    	else if typeWidth pk1 == W32 then
-    	    	    code1 `snocOL` promote src1 `appOL` code2 `snocOL`
-    	    	    FCMP True FF64 tmp src2
-    	    	else
-    	    	    code1 `appOL` code2 `snocOL` promote src2 `snocOL`
-    	    	    FCMP True FF64 src1 tmp
+        promote x = FxTOy FF32 FF64 x tmp
+
+        pk1   = cmmExprType dflags x
+        pk2   = cmmExprType dflags y
+
+        code__2 =
+                if pk1 `cmmEqType` pk2 then
+                    code1 `appOL` code2 `snocOL`
+                    FCMP True (cmmTypeSize pk1) src1 src2
+                else if typeWidth pk1 == W32 then
+                    code1 `snocOL` promote src1 `appOL` code2 `snocOL`
+                    FCMP True FF64 tmp src2
+                else
+                    code1 `appOL` code2 `snocOL` promote src2 `snocOL`
+                    FCMP True FF64 src1 tmp
     return (CondCode True cond code__2)
